# vi:si:et:sw=4:sts=4:ts=4

from codeina.test.common import unittest
from codeina.installer.apt_installer import Installer
from codeina.productlist import Plugin

class test_apt_check(unittest.TestCase):

    def setUp(self):
        from codeina.check import get_distro_name
        if get_distro_name() not in ['debian', 'ubuntu']:
            raise unittest.SkipTest('not a debian based system, no apt')
        self.package = Plugin()
        self.Installer = Installer() 

    def test_is_installed_real_package(self):
        self.package.nick = "gstreamer0.10-plugins-base"
        self.assertEqual(True, self.Installer.is_installed(self.package))

    def test_is_installed_real_package_not_installed(self):
        self.package.nick = "gstreamer0.10-plugins-bad-doc" 
        self.assertEqual(False, self.Installer.is_installed(self.package))

    def test_is_installed_fake_package(self):
        self.package.nick = "gstreamer0.10-plugins-somefakename" 
        self.assertEqual(False, self.Installer.is_installed(self.package))
