# -*- Mode: Python; test-case-name: codeina.test.test_product_list -*-
# vi:si:et:sw=4:sts=4:ts=4

from codeina.test.common import unittest
from codeina import providers
import os

class TestCodeinaProviders(unittest.TestCase):

    def setUp (self):

        # FIXME
        raise unittest.SkipTest('needs twisted reactor mess cleaning up')

        self.p1 = providers.CodeinaProvider ()
        self.p1._xml_files = [os.path.join( os.path.dirname( os.path.realpath(__file__)), '..', '..', 'providers', 'fluendo_3.xml')]
        self.p1._product_lists = None
        from codeina import check
        check.OS_NAME = 'Linux'
        check.ARCH_NAME = 'i386'
        check.DISTRO_NAME = 'ubuntu'
        check.DISTRO_VERSION = 'gutsy'
        check.GST_CORE_VERSION = check.Version ('0.10.6')
        check.GST_PLUGINS_BASE_VERSION = check.Version ('0.10.6')

    def test_providers_singleton (self):
        p1 = providers.CodeinaProvider ()
        p2 = providers.CodeinaProvider ()
        self.assertEquals (p1, p2)

    def test_get_all_xml_files (self):
        p1 = providers.CodeinaProvider ()
        p1._xml_files = [os.path.join( os.path.dirname( os.path.realpath(__file__)), '..', 'providers', 'fluendo_3.xml')]
        self.assertEquals (len (p1.get_all_xml_files ()), 1)

    def test_get_all_product_lists (self):
        p1 = providers.CodeinaProvider ()
        p1._xml_files = [os.path.join( os.path.dirname( os.path.realpath(__file__)), '..', '..', 'providers', 'fluendo_3.xml')]
        p1._product_lists = None
        self.assertEquals (len (p1.get_all_product_lists ()), 1)
        self.assertEquals (p1.get_all_product_lists ()[0].id, 'fluendo')

    def test_get_all_update_urls (self):
        self.assertEquals (len (self.p1.get_all_update_urls ()), 1)
        self.assertEquals (self.p1.get_all_update_urls (), ['http://piem/media/providers.xml'])

    def test_urls_same_twice (self):
        self.p1._xml_files = [os.path.join( os.path.dirname( os.path.realpath(__file__)), '..', '..', 'providers', 'fluendo_3.xml')]*2
        self.p1._product_lists = None
        self.assertEquals (len (self.p1.get_all_product_lists ()), 2)
        self.assertEquals (len (self.p1.get_all_update_urls ()), 1)
        self.assertEquals (self.p1.get_all_update_urls (), ['http://piem/media/providers.xml'])

    def test_get_providers_with_id (self):
        p1 = providers.CodeinaProvider ()
        p1._xml_files = [os.path.join( os.path.dirname( os.path.realpath(__file__)), '..', '..', 'providers', 'fluendo_3.xml'), \
                              os.path.join( os.path.dirname( os.path.realpath(__file__)), '..', '..', 'providers', 'ubuntu_gutsy.xml')]
        self.assertEquals (len (p1.get_all_xml_files ()), 2)
        p1._product_lists = None
        self.assertEquals (len (p1.get_all_product_lists ()), 2)
        self.assertEquals (len (p1.get_providers_with_id ('fluendo')), 1)
        self.assertEquals (len (p1.get_providers_with_id ('ubuntu')), 1)
        self.assertEquals (len (p1.get_providers_with_id ('fedora')), 0)

class TestCodeinaProvidersNoSkip(unittest.TestCase):
    def test_has_fluendo_providers (self):
        class mini_provider:
            def __init__(self, id):
                self.id = id
        from codeina.providers import has_fluendo_provider
        m1 = mini_provider('fluendo')
        m2 = mini_provider('fedora')
        m3 = mini_provider('ubuntu')
        self.assertEquals (has_fluendo_provider ([m1, m2, m3]), True)
        self.assertEquals (has_fluendo_provider ([m2, m3]), False)

    def test_set_fluendo_provider_first (self):
        class mini_provider:
            def __init__(self, id):
                self.id = id
        from codeina.providers import set_fluendo_provider_first
        m1 = mini_provider('fluendo')
        m2 = mini_provider('fedora')
        m3 = mini_provider('ubuntu')
        self.assertEquals (set_fluendo_provider_first ([m1, m2, m3]), [m1, m2, m3])
        self.assertEquals (set_fluendo_provider_first ([m2, m1, m3]), [m1, m2, m3])

