# -*- Mode: Python; test-case-name: codeina.test.test_product_list -*-
# vi:si:et:sw=4:sts=4:ts=4

from codeina.test.common import unittest
from codeina import web

class TestCodeinaWeb(unittest.TestCase):

    def test__check_website (self):
        self.assertEquals (web._check_website ('www.fluendo.com', '/'), True)
        self.assertEquals (web._check_website ('www.flundo.com', '/'), False)
        self.assertEquals (web._check_website ('www.fluendo.com', '/asdjklfgh'), False)
        self.assertEquals (web._check_website ('www.fluendo.com', '/downloads.php'), True)

    def test_website_ok (self):
        self.assertEquals (web.website_exists('www.fluendo.com'), True)
        self.assertEquals (web.website_exists('http://www.fluendo.com'), True)
        
    def test_website_nok (self):
        self.assertEquals (web.website_exists('www.fluendasdfsadfo.com'), False)
        self.assertEquals (web.website_exists('http://www.fluasdfendo.com'), False)

    def test_website_with_path (self):
        self.assertEquals (web.website_exists('www.fluendo.com/asdjklfgh'), False)
        self.assertEquals (web.website_exists('www.fluendo.com/downloads.php'), True)
